rev$ = "revision 1 (2023-May-03 build)"
' Schizandra, written by Kaze (sanmayce@sanmayce.com)
' With Thinkpad 11e: Fn+Left and Fn+Right are Home and End

_Define A-Z As _INTEGER64
FramesPerSecond = 500
LastHit~&& = EpochTime~&& 'assume the start point is at 100%
Stepping = 10 '0..10 where 10 is 100%, 9 is 90%

Sepiascale = 0 ' set to 0 for colour
Greyscale = 0 ' set to 0 for colour
PurpleFlag = 0 ' set to 0 for CYAN

NormalFRGr = 3
If PurpleFlag Then NormalFRGr = 9
NormalBCKGr = 0
If PurpleFlag Then NormalBCKGr = 0

InverseFRGr = 0
If PurpleFlag Then InverseFRGr = 8
InverseBCKGr = 3
If PurpleFlag Then InverseBCKGr = 0

File_Frame_x = 1
File_Frame_y = 1

wide& = _DesktopWidth
high& = _DesktopHeight

SrcX = 2560
SrcY = 1440

If wide& < 2560 Then
    DstX = 1366 * 9 \ 10 '1229.4 / 16 = 76.8375
    DstX = 16 * 76 '1216
    DstY = 768 * 5 \ 6 '640
    FontW = 8: FontH = 16
Else ' 2K and above
    DstX = 1366 * 9 \ 10 '1229.4 / 16 = 76.8375
    DstX = (16 * 76) * 2 '2432
    DstY = (768 * 5 \ 6) * 2 '1280
    FontW = 16: FontH = 32
End If

Canvas2K& = _NewImage(SrcX, SrcY, 256)
DjudjetoHD& = _NewImage(DstX, DstY, 256)
Y_Lines = DstY / FontH
X_Columns = DstX / FontW
CursorS = 30
CursorE = 31
XdimCOL = 152 ' duplicate of X_Columns
YdimROW = 40 ' duplicate of Y_Lines

$ExeIcon:'ColumnChart.ico'
Do: Loop Until _ScreenExists
_Title "Schizandra (" + LTrim$(Str$(X_Columns)) + "x" + LTrim$(Str$(Y_Lines)) + ") - Lookuping HUGEST English wordlist, " + rev$ + "; Use D,U,L,R,H,/,G,Q and Alt+Enter"

_Dest Canvas2K&
Color NormalFRGr, NormalBCKGr
'   .oooooo..o           oooo         o8o                                         .o8
'  d8P'    `Y8           `888         `"'                                        "888
'  Y88bo.       .ooooo.   888 .oo.   oooo    oooooooo  .oooo.   ooo. .oo.    .oooo888  oooo d8b  .oooo.
'   `"Y8888o.  d88' `"Y8  888P"Y88b  `888   d'""7d8P  `P  )88b  `888P"Y88b  d88' `888  `888""8P `P  )88b
'       `"Y88b 888        888   888   888     .d8P'    .oP"888   888   888  888   888   888      .oP"888
'  oo     .d8P 888   .o8  888   888   888   .d8P'  .P d8(  888   888   888  888   888   888     d8(  888
'  8""88888P'  `Y8bod8P' o888o o888o o888o d8888888P  `Y888""8o o888o o888o `Y8bod88P" d888b    `Y888""8o
Dim Logo1$(1 To 7)
Logo1$(1) = "                                                                               "
Logo1$(2) = "  _________        .__     .__                             .___                "
Logo1$(3) = " /   _____/  ____  |  |__  |__|_____________     ____    __| _/_______ _____   "
Logo1$(4) = " \_____  \ _/ ___\ |  |  \ |  |\___   /\__  \   /    \  / __ | \_  __ \\__  \  "
Logo1$(5) = " /        \\  \___ |   Y  \|  | /    /  / __ \_|   |  \/ /_/ |  |  | \/ / __ \_"
Logo1$(6) = "/_______  / \___  >|___|  /|__|/_____ \(____  /|___|  /\____ |  |__|   (____  /"
Logo1$(7) = "        \/      \/      \/           \/     \/      \/      \/              \/ "
Dim Logo2$(1 To 7)
Logo2$(1) = "   .oooooo..o           oooo         o8o                                         .o8                    "
Logo2$(2) = "  d8P'    `Y8           `888         `" + Chr$(34) + "'                                        " + Chr$(34) + "888                    "
Logo2$(3) = "  Y88bo.       .ooooo.   888 .oo.   oooo    oooooooo  .oooo.   ooo. .oo.    .oooo888  oooo d8b  .oooo.  "
Logo2$(4) = "   `" + Chr$(34) + "Y8888o.  d88' `" + Chr$(34) + "Y8  888P" + Chr$(34) + "Y88b  `888   d'" + Chr$(34) + "" + Chr$(34) + "7d8P  `P  )88b  `888P" + Chr$(34) + "Y88b  d88' `888  `888" + Chr$(34) + "" + Chr$(34) + "8P `P  )88b "
Logo2$(5) = "       `" + Chr$(34) + "Y88b 888        888   888   888     .d8P'    .oP" + Chr$(34) + "888   888   888  888   888   888      .oP" + Chr$(34) + "888 "
Logo2$(6) = "  oo     .d8P 888   .o8  888   888   888   .d8P'  .P d8(  888   888   888  888   888   888     d8(  888 "
Logo2$(7) = "  8" + Chr$(34) + "" + Chr$(34) + "88888P'  `Y8bod8P' o888o o888o o888o d8888888P  `Y888" + Chr$(34) + "" + Chr$(34) + "8o o888o o888o `Y8bod88P" + Chr$(34) + " d888b    `Y888" + Chr$(34) + "" + Chr$(34) + "8o"
Dim Motif$(1 To 7)
For i = 1 To 7
    Motif$(i) = Logo1$(i) + " " + Logo2$(i)
Next
For j = 1 To 10
    For i = 1 To 7
        Print Right$(Motif$(i), (j - 1) * 7) + " " + Motif$(i)
    Next
Next

_Source Canvas2K&
_Dest DjudjetoHD&
Screen DjudjetoHD&

Const RSHIFTkey& = 100303
Const LSHIFTkey& = 100304
Const RCTRLkey& = 100305
Const LCTRLkey& = 100306
Const RALTkey& = 100307
Const LALTkey& = 100308

Const BACKSPCkey& = 8
Const TABkey& = 9
Const SPACEkey& = 32
Const ESCkey& = 27
Const ENTERkey& = 13

Const HOMEkey& = 18176
Const ENDkey& = 20224

Const INSkey& = 20992
Const DELkey& = 21248

Const PGUPkey& = 18688
Const PGDNkey& = 20736

Const LEFTkey& = 19200
Const RIGHTkey& = 19712
Const UPkey& = 18432
Const DOWNkey& = 20480

Dim Shared CursorS As Integer
Dim Shared CursorE As Integer

Dim Shared Schizandra$(1 To 45)
Schizandra$(1) = "AHD, American_Heritage_Dictionary_4_(En-En)_WHOLEWORDS.dsl                                                          "
Schizandra$(2) = "BNC, Machine-Learning_British-National-Corpus_XML-edition.tar                                                       "
Schizandra$(3) = "BRE, Britannica_Encyclopedia_2010_1.563_miled_(En-En)_ANSI.dsl                                                      "
Schizandra$(4) = "CAL, Cambridge_Advanced_Learner's_Dictionary_4th_Ed_(En-En).dsl                                                     "
Schizandra$(5) = "CCA, Collins_COBUILD_Advanced_Learner's_English_Dictionary_(5th_ed)_(En-En)_WHOLEWORDS.dsl                          "
Schizandra$(6) = "DMC, DeepMind_Q_and_A_Dataset_cnn_downloads_(92579_files).tar                                                       "
Schizandra$(7) = "DMD, DeepMind_Q_and_A_Dataset_dailymail_downloads_(219506_files).tar                                                "
Schizandra$(8) = "EDR, encyclopediadramaticase-20150628-current.tar                                                                   "
Schizandra$(9) = "EJD, Encyclopaedia_Judaica_(in_22_volumes)_TXT.tar                                                                  "
Schizandra$(10) = "EJN, ENAMDICT_Japanese_names                                                                                        "
Schizandra$(11) = "FDU, For_Dummies_978-ebooks_Collection.tar                                                                          "
Schizandra$(12) = "GGB, Google_Books_corpus_version_20130501_English_All_Nodes.txt                                                     "
Schizandra$(13) = "GNS, Genesis_Library_English / Genesis_Library_English_fiction (2,290,923 .TXT files)                               "
Schizandra$(14) = "HCN, Hacker_News_2006_to_2017-jul.json                                                                              "
Schizandra$(15) = "IST, INTERNET_SACRED_TEXT_ARCHIVE_DVD-ROM_9_(English_140479_htm_files).tar                                          "
Schizandra$(16) = "LDC, Longman_Dictionary_of_Contemporary_English_5th_Ed_(En-En)_WHOLEWORDS.dsl                                       "
Schizandra$(17) = "MCD, Macmillan_English_Dictionary_(En-En)_.dsl                                                                      "
Schizandra$(18) = "MCT, Macmillan_English_Thesaurus_(En-En).dsl                                                                        "
Schizandra$(19) = "NSO, New_Shorter_Oxford_English_Dictionary_fifth_edition.tar                                                        "
Schizandra$(20) = "OED, Oxford_English_Dictionary_2nd_Edition_Version_4_(En-En)_WHOLEWORDS.dsl.txt                                     "
Schizandra$(21) = "OSH, OSHO.TXT                                                                                                       "
Schizandra$(22) = "PGT, Project_Gutenberg_DVD-2010_(29180_files).tar                                                                   "
Schizandra$(23) = "RDD, Reddit_Comments_(JSON_objects)_from_(2005-12_to_2018-01).json                                                  "
Schizandra$(24) = "RHW, Random_House_Webster's_Unabridged_Dictionary_(En-En)_.dsl                                                      "
Schizandra$(25) = "SNT, Machine-Learning_WestburyLab.NonRedundant.UsenetCorpus_(47860_English_language_non-binary-file_news_groups).tar"
Schizandra$(26) = "STX, archive.org_stackexchange_(346_corpora_2017-Oct-12).tar                                                        "
Schizandra$(27) = "TAL, the-anarchist-library-2016-01-18-en_html.tar                                                                   "
Schizandra$(28) = "TXF, TEXTFILES.COM_(58096_files).tar                                                                                "
Schizandra$(29) = "URB, Machine-Learning_Urban_Dictionary_Definitions_Corpus_(1999_-_May-2016).words.json                              "
Schizandra$(30) = "WKD, dumps.wikimedia.org_Germany_dewiki-20180220-pages-articles.xml                                                 "
Schizandra$(31) = "WKE, dumps.wikimedia.org_English_enwiki-20180220-pages-articles.xml                                                 "
Schizandra$(32) = "WKF, dumps.wikimedia.org_France_frwiki-20180220-pages-articles.xml                                                  "
Schizandra$(33) = "WKI, dumps.wikimedia.org_Italy_itwiki-20180220-pages-articles.xml                                                   "
Schizandra$(34) = "WKN, dumps.wikimedia.org_Netherlands_nlwiki-20180220-pages-articles.xml                                             "
Schizandra$(35) = "WKP, dumps.wikimedia.org_Portugal_ptwiki-20180220-pages-articles.xml                                                "
Schizandra$(36) = "WKS, dumps.wikimedia.org_Spain_eswiki-20180220-pages-articles.xml                                                   "
Schizandra$(37) = "WMB, dumps.wikimedia.org_English_enwikibooks-20180220-pages-articles.xml                                            "
Schizandra$(38) = "WMN, dumps.wikimedia.org_English_enwikinews-20180220-pages-articles.xml                                             "
Schizandra$(39) = "WMP, dumps.wikimedia.org_English_specieswiki-20180220-pages-articles.xml                                            "
Schizandra$(40) = "WMQ, dumps.wikimedia.org_English_enwikiquote-20180220-pages-articles.xml                                            "
Schizandra$(41) = "WMS, dumps.wikimedia.org_English_enwikisource-20180220-pages-articles.xml                                           "
Schizandra$(42) = "WMU, dumps.wikimedia.org_English_enwikiversity-20180220-pages-articles.xml                                          "
Schizandra$(43) = "WMV, dumps.wikimedia.org_English_enwikivoyage-20180220-pages-articles.xml                                           "
Schizandra$(44) = "WMW, dumps.wikimedia.org_English_enwiktionary-20180220-pages-articles.xml                                           "
Schizandra$(45) = "WUD, Webster's_Unabridged_3_(En-En)_WHOLEWORDS_ANSI.dsl                                                             "

$If WINDOWS Then
    PSPlike$ = _CWD$ ' unreliable, when starting PSP.EXE from (C:\mingw, current drive and folder) with D:\PSP.EXE and current folder on D: is D:\temp then _CWD$ instead of "D:\" is "D:\temp", why?!
    If Right$(PSPlike$, 1) <> "\" Then PSPlike$ = PSPlike$ + "\"
    PathToEngage$ = _StartDir$
    If Right$(PathToEngage$, 1) <> "\" Then PathToEngage$ = PathToEngage$ + "\"
$Else
    PSPlike$ = _CWD$
    If Right$(PSPlike$, 1) <> "/" Then PSPlike$ = PSPlike$ + "/"
    PathToEngage$ = _StartDir$
    If Right$(PathToEngage$, 1) <> "/" Then PathToEngage$ = PathToEngage$ + "/"
$End If

If wide& < 2560 Then
    FNThandle4& = _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 16, "MONOSPACE")
    If FNThandle4& > 0 Then _Font FNThandle4&, DjudjetoHD&
    FontW = 8: FontH = 16
Else
    FNThandle4& = _LoadFont(PSPlike$ + "Px437_Cordata_PPC-400.ttf", 32, "MONOSPACE") '16x32 Cordata
    If FNThandle4& > 0 Then _Font FNThandle4&
    FontW = 16: FontH = 32
End If

GraphicOrTextFlag = 1 '0 for Text; 1 for GRAPHICS
If GraphicOrTextFlag Then
    'Screen _NewImage(XdimCOL * _FontWidth, YdimROW * _FontHeight, 0 + 256)
Else
    'Screen _NewImage(XdimCOL, YdimROW, 0)
End If
Do: Loop Until _ScreenExists
_ScreenMove 102, 3

' Here is the layout:
' The window-frame is 1..crx or 1..128 |  The file-frame is 1..LongestLine
'                     .         .      |                    .
'                     .         .      |                    .
'                     cry       60     |                    filecount
'              FileArrayWINDOW$(60)    |          FileArray(filecount)
' if File_Frame_x < 128 then PADDING to 128 else File_Frame_x = 1..LongestLine-(128-1)
' if File_Frame_y < 60 then PADDING to 60 else File_Frame_y = 1..filecount-(60-1)

'Lazy me, in order to avoid editing the existing r.3+ code FileArray$() became function, array no more!
Dim FileArrayWINDOW$(YdimROW)

_ControlChr Off 'without it couldn't _MAPUNICODE these 7, 9..13, 28..31
_AllowFullScreen _Stretch , _Smooth 'allow Alt+Enter, notice it has to be here before the screen/font stuff below, otherwise it enters all 4 modes back to back.
GoSub RefreshPalette

X = 0: Y = 0
StepScroll = 1
_PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1))
AnimationMode = 194 ' it ends after 138 copying frames/loops i.e. becoming 0
Do
    If AnimationMode Then
        If AnimationMode > 30 Then Drctn$ = "DR" 'Down-Right i.e. top-left to bottom-right diagonal
        If AnimationMode < 30 Then Drctn$ = "UR" 'Up-Right i.e. bottom-left to up-right diagonal
        AnimationMode = AnimationMode - 1
    Else
        Drctn$ = InKey$
    End If
    Select Case Drctn$
        Case "DR":
            If (Y + StepScroll) + (DstY - 1) <= SrcY - 1 Then Y = (Y + StepScroll): '_PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1))
            If (X + StepScroll) + (DstX - 1) <= SrcX - 1 Then X = (X + StepScroll): '_PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1))
            _PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1)) ' Just once
        Case "UR":
            Y = Y - StepScroll: If Y < 0 Then Y = 0
            '_PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1))
            If (X + StepScroll) + (DstX - 1) <= SrcX - 1 Then X = (X + StepScroll): '_PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1))
            _PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1)) ' Just once
        Case "1": _KeyClear: StepScroll = 1
        Case "2": _KeyClear: StepScroll = 2
        Case "3": _KeyClear: StepScroll = 3
        Case "4": _KeyClear: StepScroll = 4
        Case "5": _KeyClear: StepScroll = 5
        Case "6": _KeyClear: StepScroll = 6
        Case "7": _KeyClear: StepScroll = 7
        Case "8": _KeyClear: StepScroll = 8
        Case "9": _KeyClear: StepScroll = 9
        Case "h", "H": _KeyClear: X = 0: Y = 0: _PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1))
            _Display
        Case "l", "L": _KeyClear: X = X - StepScroll: If X < 0 Then X = 0
            _PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1))
            _Display
        Case "r", "R": _KeyClear: If (X + StepScroll) + (DstX - 1) <= SrcX - 1 Then X = (X + StepScroll): _PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1))
            _Display
        Case "u", "U": _KeyClear: Y = Y - StepScroll: If Y < 0 Then Y = 0
            _PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1))
            _Display
        Case "d", "D": _KeyClear: If (Y + StepScroll) + (DstY - 1) <= SrcY - 1 Then Y = (Y + StepScroll): _PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1))
            _Display
        Case "g", "G":
            Sepiascale = 1
            Greyscale = 0
            GoSub RefreshPalette
            _Display
        Case "q", "Q": System
        Case "/"
            _Title "Schizandra (" + LTrim$(Str$(X_Columns)) + "x" + LTrim$(Str$(Y_Lines)) + ") - Lookuping HUGEST English wordlist, " + rev$ + "; Use Alt+Enter"
            RsmLoopSLASH2:
            _KeyClear
            Do
                ' Kaze's Galeon's non-fix of the problem (on Fedora 35) below [
                Xbug = _KeyHit
                If Xbug Then
                    If Xbug < 0 Then 'negative value means key released
                        Xbug = -Xbug
                        If Xbug = 47 And _KeyDown(47) = 0 Then Exit Do
                    Else
                    End If
                End If
                ' Kaze's Galeon's non-fix of the problem (on Fedora 35) below ]
                key$ = InKey$
            Loop
            For i = 1 To 3333
                StupidFix$ = InKey$
                If _KeyDown(47) Then GoTo RsmLoopSLASH2
            Next
            'Exit Do
            F3pattern$ = DrawBoxShadow3exactSLASH4$(3, 3, 9, 107, "/(released): Case-Insensitive Filter Panel, only matching lines to be shown")
            CurrentWord$ = LCase$(F3pattern$)
            Locate , , 0: _Display
            dict03sub
            _PutImage (0, 0), Canvas2K&, DjudjetoHD&, (X, Y)-(X + (DstX - 1), Y + (DstY - 1))
            _Title "Schizandra (" + LTrim$(Str$(X_Columns)) + "x" + LTrim$(Str$(Y_Lines)) + ") - Lookuping HUGEST English wordlist, " + rev$ + "; Use D,U,L,R,H,/,G,Q and Alt+Enter"
            _Display
    End Select
    _Limit FramesPerSecond
    If AnimationMode Then
        _Delay .01
    Else
        Sleep
    End If
Loop

RefreshPalette:
SetOriginalColorScheme
'_PaletteColor 1, _RGB32(0, 170 \ 4, 170 \ 4) ' making color #001 the shadow for color #003
' Making the shadow counterparts (16..31) for colors 00..15 in 256 colors mode [[[
ReDim RGB(0 To 47) As Integer 'color intensity array
ReDim red(0 To 15) As Single
ReDim grn(0 To 15) As Single
ReDim blu(0 To 15) As Single
For c& = 0 To 15
    'OUT &H3C7, c&                  'set color attribute to read
    value32& = _PaletteColor(c&, 0) 'sets color value to read of an image page handle.
    'red% = INP(&H3C9)
    red% = _Red32(value32&)
    'green% = INP(&H3C9)
    green% = _Green32(value32&)
    'blue% = INP(&H3C9)
    blue% = _Blue32(value32&)
    RGB(c& * 3) = red%: RGB((c& * 3) + 1) = green%: RGB((c& * 3) + 2) = blue%
    red(c&) = red%
    grn(c&) = green%
    blu(c&) = blue%
Next

'Sepiascale
'outputRed = (inputRed * .393) + (inputGreen * .769) + (inputBlue * .189)
'outputGreen = (inputRed * .349) + (inputGreen * .686) + (inputBlue * .168)
'outputBlue = (inputRed * .272) + (inputGreen * .534) + (inputBlue * .131)
For i = 0 To 15
    If Sepiascale Then _PaletteColor i, _RGB32(Int(red(i) * .393) + Int(grn(i) * .769) + Int(blu(i) * .189), Int(red(i) * .349) + Int(grn(i) * .686) + Int(blu(i) * .168), Int(red(i) * .272) + Int(grn(i) * .534) + Int(blu(i) * .131))
    If Greyscale Then _PaletteColor i, _RGB32((red(i) + grn(i) + blu(i)) \ 3, (red(i) + grn(i) + blu(i)) \ 3, (red(i) + grn(i) + blu(i)) \ 3)
    'Amberscale
Next

For c& = 0 To 15
    'OUT &H3C7, c&                  'set color attribute to read
    value32& = _PaletteColor(c&, 0) 'sets color value to read of an image page handle.
    'red% = INP(&H3C9)
    red% = _Red32(value32&)
    'green% = INP(&H3C9)
    green% = _Green32(value32&)
    'blue% = INP(&H3C9)
    blue% = _Blue32(value32&)
    _PaletteColor c& + 16, _RGB32(red% \ 3, green% \ 3, blue% \ 3)
Next
' Making the shadow counterparts (16..31) for colors 00..15 in 256 colors mode ]]]
Return

Sub SetOriginalColorScheme
    Shared GraphicOrTextFlag
    'If GraphicOrTextFlag = 0 Then
    'Colorscale .000..255:

    '0   Black            0             0             0
    '1   Dark Blue        0             0             168
    '2   Dark Green       0             168           0
    '3   Dark Cyan        0             168           168
    '4   Dark Red         168           0             0
    '5   Dark Magenta     168           0             168
    '6   Dark Yellow      168           84            0
    '7   Light Grey       168           168           168

    '8+0 Dark Grey        84            84            84
    '8+1 Blue             84            84            252
    '8+2 Green            84            252           84
    '8+3 Cyan             84            252           252
    '8+4 Red              252           84            84
    '8+5 Magenta          252           84            252
    '8+6 Yellow           252           252           84
    '8+7 White            252           252           252

    'Colorscale 00..63:
    '0   Black            0      0       0
    '1   Dark Blue        0      0      42
    '2   Dark Green       0     42       0
    '3   Dark Cyan        0     42      42
    '4   Dark Red        42      0       0
    '5   Dark Magenta    42      0      42
    '6   Dark Yellow     42     21       0
    '7   Light Grey      42     42      42

    '8+0 Dark Grey       21     21      21
    '8+1 Blue            21     21      63
    '8+2 Green           21     63      21
    '8+3 Cyan            21     63      63
    '8+4 Red             63     21      21
    '8+5 Magenta         63     21      63
    '8+6 Yellow          63     63      21
    '8+7 White           63     63      63

    'Colorscale
    _PaletteColor 0, _RGB32(0, 0, 0)
    _PaletteColor 1, _RGB32(0, 0, 168)
    _PaletteColor 2, _RGB32(0, 168, 0)
    _PaletteColor 3, _RGB32(0, 168, 168)
    _PaletteColor 4, _RGB32(168, 0, 0)
    _PaletteColor 5, _RGB32(168, 0, 168)
    _PaletteColor 6, _RGB32(168, 84, 0)
    _PaletteColor 7, _RGB32(168, 168, 168)

    _PaletteColor 8, _RGB32(84, 84, 84)
    _PaletteColor 9, _RGB32(84, 84, 252)
    _PaletteColor 10, _RGB32(84, 252, 84)
    _PaletteColor 11, _RGB32(84, 252, 252)
    _PaletteColor 12, _RGB32(252, 84, 84)
    _PaletteColor 13, _RGB32(252, 84, 252)
    _PaletteColor 14, _RGB32(252, 252, 84)
    _PaletteColor 15, _RGB32(252, 252, 252)

    _PaletteColor 3, _RGB32(0, 168 - 10, 168 - 10) 'darker Cyan
    _PaletteColor 8, _RGB32(84 - 22, 84 - 22, 84 - 22) 'make Grey darker
    _PaletteColor 1, _RGB32(0, 100, 160) 'make the Amber more darker

    ' Change the Red to Carminish
    _PaletteColor 4, _RGB32(110, 2, 25) 'Carminish
    _PaletteColor 4 + 8, _RGB32(110 + 44, 2 + 44, 25 + 44) 'make Carmin more lighter
    ' Change the Purple to SteelBlue
    _PaletteColor 5, _RGB32(33, 99, 122)
    _PaletteColor 5 + 8, _RGB32(33 + 44, 99 + 44, 122 + 44)
    ' Change the Green to Cyanish
    _PaletteColor 2, _RGB32(1, 90, 80)
    _PaletteColor 2 + 8, _RGB32(1 + 44, 90 + 44, 80 + 44)
    _PaletteColor 6, _RGB32(168 - 20, 84 - 20, 0) 'make the Amber more darker
    _PaletteColor 6 + 8, _RGB32(168 + 24, 84 + 24, 0)
    'End If
End Sub

Sub dict03sub
    Shared CurrentWord$
    Shared FramesPerSecond, Stepping
    Const dict03_RecordLen = 47 '4+10+31 +2 for CRLF
    Dim dict03_lfixedCRLF As String * dict03_RecordLen
    Dim dict03_lfixedCRLFhighlight As String * dict03_RecordLen
    dict03_TotalWrd = 0

    dict03$ = "Schizandrafield_Corpus_revision_D_(45-corpora_-unique-words).sorted"

    If _FileExists(PSPlike$ + dict03$ + ".ind") = 0 Then 'check for existance [[[
        f01 = FreeFile
        Open dict03$ For Binary As #f01
        If LOF(f01) Then

            f02 = FreeFile
            Open dict03$ + ".ind" For Binary As #f02 'LEN = 35 + 2 + 8 + 8 '+2 for CRLF and DWORD+DWORD as padded HEX
            Do While Not EOF(f01)
                Line Input #f01, l$
                dict03_lfixedCRLF$ = l$ + String$(45 - Len(l$), " ") + Chr$(13) + Chr$(10)
                Put #f02, , dict03_lfixedCRLF$: dict03_TotalWrd = dict03_TotalWrd + 1
            Loop
            Close #f01, #f02
            'SHELL _HIDE "CMD /C sort " + CHR$(34) + dict03$ + ".ind" + CHR$(34) + " > " + CHR$(34) + "sorted_" + dict03$ + ".ind" + CHR$(34)

        Else
            $If WINDOWS Then
                Play "L16V32O3g-g-<<d+"
            $End If
            Close #f01
        End If 'If LOF(f01) Then
    Else
        dict03_TotalWrd = 1005624651
    End If 'check for existance ]]]
    If _FileExists(PSPlike$ + dict03$ + ".ind") <> 0 Then 'check for existance [[[
        f02 = FreeFile
        Open PSPlike$ + dict03$ + ".ind" For Random Access Read As #f02 Len = dict03_RecordLen '35 + 2 + 8 + 8 '+2 for CRLF and DWORD+DWORD as padded HEX

        'testing 537 line:
        'alimentary                         00025E8D00000118
        'PhysicalLine = 19001 '537

        ' BINARY SEARCH [
        UCurrentWord$ = LCase$(CurrentWord$)
        WRDpos = 0
        LeftPoint = 1
        RightPoint = dict03_TotalWrd
        Do
            If RightPoint - LeftPoint <= 1 Then 'Sxsedtcheta
                Get #f02, LeftPoint, dict03_lfixedCRLF$
                If UCurrentWord$ = LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then WRDpos = LeftPoint: Exit Do
                Get #f02, RightPoint, dict03_lfixedCRLF$
                If UCurrentWord$ = LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then WRDpos = RightPoint: Exit Do
                WRDpos = LeftPoint 'THIS IS BECAUSE I NEED NEAREST word not zero!
                Exit Do
            End If
            SplitPoint = (LeftPoint + RightPoint) \ 2
            Get #f02, SplitPoint, dict03_lfixedCRLF$
            If UCurrentWord$ < LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then
                RightPoint = SplitPoint
            ElseIf UCurrentWord$ > LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then
                LeftPoint = SplitPoint
            Else
                WRDpos = SplitPoint: Exit Do
            End If
        Loop
        If WRDpos <> 0 Then
            Do While WRDpos > 1
                WRDpos = WRDpos - 1
                Get #f02, WRDpos, dict03_lfixedCRLF$
                If UCurrentWord$ <> LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then
                    WRDpos = WRDpos + 1
                    Exit Do
                End If
            Loop
            'IF WRDpos <= TotalWrd& - 16 THEN FL2wrd& = WRDpos ELSE FL2wrd& = TotalWrd& - 16
        End If
        ' BINARY SEARCH ]

        $If WINDOWS Then
            Play "v20o2l20geb"
        $End If
        PhysicalLine = WRDpos
        'PhysicalLine = 277315 '277315 total; WARNING! 61358 is 'dictionary' - cannot be found because words as 'dicarch' confuse the binary search!
        'GET #f02, (PhysicalLine - 1) * (35 + 2 + 8 + 8) + 1, dict03_lfixedCRLF$ 'when OPENed for BINARY
        Get #f02, PhysicalLine, dict03_lfixedCRLF$

        'PRINT "EntryHead: "; LEFT$(EntryAll$, INSTR(EntryAll$, CHR$(13)) - 1)
        'EntryTail$ = "EntryTail: " + RIGHT$(EntryAll$, LEN(EntryAll$) - INSTR(EntryAll$, CHR$(9)))
        'PRINT EntryTail$
        'PRINT "[" + EntryAll$ + "]"

        ' Scrolling into 3D djamtche [
        'SUB DrawBoxShadow3 (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
        If Len(dict03$) > 70 Then Reduced$ = "..." + Right$(dict03$, 70) Else Reduced$ = dict03$
        TopLrow = 3 + 3 + 1: TopLcol = 3 + 1: BottomRrow = 35 + 3: BottomRcol = 125 '+ 22
        Call DrawBoxShadowOED(TopLrow, TopLcol, BottomRrow, BottomRcol, Reduced$, 6)
        BckGRcolor = 6
        s$ = LTrim$(Str$(PhysicalLine))
        If Len(s$) > 3 Then
            If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
            s$ = ""
            For i = 1 To Len(x$) Step 3
                s$ = s$ + Mid$(x$, i, 3) + ","
            Next
            s$ = Left$(s$, Len(s$) - 1)
        End If
        s$ = LTrim$(s$)
        Padded$ = "0,000,000,000"
        Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
        Color 0, BckGRcolor: Locate BottomRrow, TopLcol + 97: Print "[ Entry: ";: Color 7, BckGRcolor: Print Padded$;: Color 0, BckGRcolor: Print " ]";
        Locate , , 0: _Display

        DjamPoolLength = BottomRcol - TopLcol + 1 - 4
        DjamPoolHeight = BottomRrow - TopLrow + 1 - 4
        CurrentPos = PhysicalLine ' Notice that CurrentPos = 1..(dict03_TotalWrd - DjamPoolHeight + 1)
        If CurrentPos > (dict03_TotalWrd - DjamPoolHeight + 1) Then CurrentPos = (dict03_TotalWrd - DjamPoolHeight + 1)
        PoolLinePos = 1
        LastHit~&& = EpochTime~&&: Stepping = 10
        Do
            'Do While _MouseInput: Loop
            'Pcolor~& = Point(_MouseX, _MouseY): Locate 1, 1: Print Pcolor~&: _Display
            key$ = InKey$
            'DO: a$ = INKEY$: LOOP UNTIL a$ <> "" ' prevent ASC empty string read error
            If key$ <> "" Then
                code% = Asc(key$):
                If code% Then ' ASC returns any value greater than 0
                    Select Case Asc(key$)
                        Case 32:
                        Case 65 TO 97: 'PRINT key$;
                        Case Asc("a") TO Asc("z"): 'PRINT key$;
                            'CASE 27: COLOR 7, 0: SYSTEM 'END
                    End Select
                Else
                    Select Case Asc(key$, 2)
                        Case 72:
                            LastHit~&& = EpochTime~&&: Stepping = 10
                            If PoolLinePos > 1 Then
                                PoolLinePos = PoolLinePos - 1
                            Else
                                If CurrentPos > 1 Then CurrentPos = CurrentPos - 1
                            End If
                        Case 80:
                            LastHit~&& = EpochTime~&&: Stepping = 10
                            If PoolLinePos < DjamPoolHeight Then
                                PoolLinePos = PoolLinePos + 1
                            Else
                                If CurrentPos < (dict03_TotalWrd - DjamPoolHeight + 1) Then CurrentPos = CurrentPos + 1
                            End If
                        Case 75: 'Left
                        Case 77: 'Right
                        Case 71: 'Home
                            LastHit~&& = EpochTime~&&: Stepping = 10
                            PoolLinePos = 1
                            CurrentPos = 1
                        Case 79: 'End
                            LastHit~&& = EpochTime~&&: Stepping = 10
                            PoolLinePos = DjamPoolHeight
                            CurrentPos = (dict03_TotalWrd - DjamPoolHeight + 1)
                        Case 73: 'PgUp
                            LastHit~&& = EpochTime~&&: Stepping = 10
                            If CurrentPos - DjamPoolHeight >= 1 Then CurrentPos = CurrentPos - DjamPoolHeight
                        Case 81: 'PgDn
                            LastHit~&& = EpochTime~&&: Stepping = 10
                            If CurrentPos + DjamPoolHeight <= (dict03_TotalWrd - DjamPoolHeight + 1) Then CurrentPos = CurrentPos + DjamPoolHeight
                        Case 61: 'F3
                            LastHit~&& = EpochTime~&&: Stepping = 10
                        Case 13: 'Enter
                            LastHit~&& = EpochTime~&&: Stepping = 10
                    End Select
                End If
            End If

            Select Case EpochTime~&& - LastHit~&&
                Case Is > 13 * 10: Stepping = 0: '_Title "Stepping 0: _Limit =" + Str$(Int(FramesPerSecond * (Stepping * .1)) + 5) 'the 13th minute is maximum idleness
                Case Is > 9 * 10: Stepping = 1: '_Title "Stepping 1: _Limit =" + Str$(Int(FramesPerSecond * (Stepping * .1)) + 5)
                Case Is > 8 * 10: Stepping = 2: '_Title "Stepping 2: _Limit =" + Str$(Int(FramesPerSecond * (Stepping * .1)) + 5)
                Case Is > 7 * 10: Stepping = 3: '_Title "Stepping 3: _Limit =" + Str$(Int(FramesPerSecond * (Stepping * .1)) + 5)
                Case Is > 6 * 10: Stepping = 4: '_Title "Stepping 4: _Limit =" + Str$(Int(FramesPerSecond * (Stepping * .1)) + 5)
                Case Is > 5 * 10: Stepping = 5: '_Title "Stepping 5: _Limit =" + Str$(Int(FramesPerSecond * (Stepping * .1)) + 5)
                Case Is > 4 * 10: Stepping = 6: '_Title "Stepping 6: _Limit =" + Str$(Int(FramesPerSecond * (Stepping * .1)) + 5)
                Case Is > 3 * 10: Stepping = 7: '_Title "Stepping 7: _Limit =" + Str$(Int(FramesPerSecond * (Stepping * .1)) + 5)
                Case Is > 2 * 10: Stepping = 8: '_Title "Stepping 8: _Limit =" + Str$(Int(FramesPerSecond * (Stepping * .1)) + 5)
                Case Is > 1 * 10: Stepping = 9: '_Title "Stepping 9: _Limit =" + Str$(Int(FramesPerSecond * (Stepping * .1)) + 5)
                Case Else
                    '_Title "Stepping 10: _Limit =" + Str$(Int(FramesPerSecond * (Stepping * .1)) + 5)
            End Select
            _Limit Int(FramesPerSecond * (Stepping * .1)) + 9 'to avoid 0

            If _KeyDown(13) Then ' Enter

            End If
            If _KeyDown(18176) Then ' Home

            End If
            If _KeyDown(20224) Then ' End

            End If
            If _KeyDown(15616) Then ' F3

            End If
            If _KeyDown(18688) Then ' PgUp

            End If
            If _KeyDown(20736) Then ' PgDn

            End If

            GoSub Txpo3
        Loop Until _KeyDown(27)
        LastHit~&& = EpochTime~&&: Stepping = 10
        _Limit Int(FramesPerSecond * (Stepping * .1)) + 9 'to avoid 0
        ' Scrolling into 3D djamtche ]
        Close #f02
    End If 'check for existance ]]]
    '_KEYCLEAR 2
    Do While InKey$ <> "": Loop
    While _MouseInput: Wend
    Exit Sub

    Txpo3:
    If CurrentPos > (dict03_TotalWrd - DjamPoolHeight + 1) Then ' because dict03_TotalWrd - (dict03_TotalWrd - DjamPoolHeight + 1) + 1 isDjamPoolHeight
        PoolLinePos = CurrentPos - (dict03_TotalWrd - DjamPoolHeight + 1)
    End If
    Get #f02, CurrentPos + (PoolLinePos - 1), dict03_lfixedCRLFhighlight$ 'we need this in order to highlight (lowering the strain on the eye) all such words
    For i = 1 To MIN&(DjamPoolHeight, dict03_TotalWrd) ' with dictionaries all are bigger than ~40 lines
        Get #f02, CurrentPos + (i - 1), dict03_lfixedCRLF$
        Locate TopLrow + 2 + (i - 1), TopLcol + 2
        If i = PoolLinePos Then
            Color BckGRcolor, 0
        Else
            If UCurrentWord$ = LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then Color 7, BckGRcolor Else Color 0, BckGRcolor
            If LCase$(RTrim$(Mid$(dict03_lfixedCRLFhighlight$, 15, 31))) = LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then Color 15, BckGRcolor
        End If
        'PRINT LEFT$(dict03_lfixedCRLF$, INSTR(dict03_lfixedCRLF$, CHR$(13)) - 1) + STRING$(DjamPoolLength - LEN(LEFT$(dict03_lfixedCRLF$, INSTR(dict03_lfixedCRLF$, CHR$(13)) - 1)), " ");
        For j = 1 To 45
            If Left$(Schizandra$(j), 3) = Left$(dict03_lfixedCRLF$, 3) Then
                addon$ = RTrim$(Right$(Schizandra$(j), Len(Schizandra$(j)) - 4))
                PaddingLEN = DjamPoolLength - Len(Left$(dict03_lfixedCRLF$, InStr(dict03_lfixedCRLF$, Chr$(13)) - 1))
                If Len(addon$) <= PaddingLEN Then
                    addon$ = addon$ + String$(PaddingLEN - Len(addon$), " ")
                Else
                    addon$ = Left$(addon$, PaddingLEN)
                End If
                Print Left$(dict03_lfixedCRLF$, InStr(dict03_lfixedCRLF$, Chr$(13)) - 1) + addon$;
            End If
        Next
    Next
    s$ = LTrim$(Str$(CurrentPos + PoolLinePos - 1))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)
    Padded$ = "0,000,000,000"
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    Color 0, BckGRcolor: Locate BottomRrow, TopLcol + 97: Print "[ Entry: ";: Color 7, BckGRcolor: Print Padded$;: Color 0, BckGRcolor: Print " ]";
    _Display 'in order to not having frozen screen
    Return
End Sub

Sub DrawBoxShadowOED (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$, BckGRcolor)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, filecount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    'Shadow
    Color 8, BACKGR
    For i = 1 To YdimROW 'MIN&(YdimROW, filecount)
        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
        'ELSE
        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
        'END IF
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            'Locate i, TopLcol + 1: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
            ' When using smooth scroll i.e. not on CHAR boundary we need GRAPHICAL darkening [
            CursorGraphX = i
            For CursorGraphY = (TopLcol + 1) To (TopLcol + 1) + BottomRcol - TopLcol
                'Line ((CursorGraphY - 1) * _FontWidth, (CursorGraphX - 1) * _FontHeight)-((CursorGraphY) * _FontWidth - 1, (CursorGraphX) * _FontHeight - 1), 8, B
                For PX = (CursorGraphY - 1) * _FontWidth To (CursorGraphY) * _FontWidth - 1
                    For PY = (CursorGraphX - 1) * _FontHeight To (CursorGraphX) * _FontHeight - 1
                        Pcolor~& = Point(PX, PY)
                        If Pcolor~& <= 15 Then ' don't change if already shadowed
                            Line (PX, PY)-(PX, PY), Pcolor~& + 16 '1
                        End If
                    Next
                Next
            Next
            ' When using smooth scroll i.e. not on CHAR boundary we need GRAPHICAL darkening ]
        End If
    Next
    _Display: _Delay .3
    'Outer frame
    Locate TopLrow, TopLcol
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: Locate TopLrow, TopLcol + 2: Print "[ Dictionary: ";: Color 15, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: Locate i, TopLcol: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    Locate BottomRrow, TopLcol
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)
    'Inner frame
    'In case of YdimROW = 40 then shrunk panel
    shrunkP = 0
    Locate TopLrow + 1, TopLcol + 1
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));
    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 2 To BottomRrow - 1
        Color 0, BckGRcolor: Locate i, TopLcol + 1: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    Locate BottomRrow - 1, TopLcol + 1
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    Locate TopLrow + 2, TopLcol + 2
    Color 7, BckGRcolor

    HelpLine$ = "Up,Dn,PgUp,PgDn,Home,End,Enter,Esc,F3"
    Color 0, BckGRcolor: Locate BottomRrow, TopLcol + 2: Print "[ Keys: ";: Color 7, BckGRcolor: Print HelpLine$;: Color 0, BckGRcolor: Print " ]";
    Color 0, BckGRcolor: Locate BottomRrow, TopLcol + 2 + 49: Print "[ Jump: ";: Color 7, BckGRcolor: Print "ForwardToFirstLineMatchingThisText";: Color 0, BckGRcolor: Print " ]";
    _Display
    'Match$ = InputLineSLASH$(TopLrow + 39 - 23 - shrunkP, TopLcol + 2, BottomRcol - TopLcol - 1 - 2)
    Locate 1, 1, 1, CursorS, CursorE
End Sub

Sub ExpandTabs (l$)
    Shared XdimCOL
    If InStr(l$, Chr$(9)) Then
        TabV% = 8
        b$ = "": f& = 0
        PossibleRecalculation = Len(l$)
        For i& = 1 To MIN&(PossibleRecalculation, XdimCOL) 'LEN(l$) ' For some reason going all the length is too slow...?! As it is, the lateral scroll is crippled!
            RemoveSpecial$ = Mid$(l$, i&, 1)
            If RemoveSpecial$ = Chr$(9) Then
                b$ = b$ + String$((f& \ TabV%) * TabV% + TabV% - f&, " ")
                '  |
                '  |
                ' \|/
                'TabV% - (f% - (f% \ TabV%) * TabV%) =
                'TabV% - (f% MOD TabV%)
                f& = (f& \ TabV%) * TabV% + TabV%
            Else
                b$ = b$ + RemoveSpecial$ 'MID$(l$, i&, 1)
                f& = f& + 1
            End If
        Next
        l$ = b$
    End If
End Sub

Function MIN& (YdimROW, filecount)
    If YdimROW < filecount Then MIN& = YdimROW Else MIN& = filecount
End Function

Function AddCommas$ (numeral)
    s$ = LTrim$(Str$(numeral))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    AddCommas$ = LTrim$(s$)
End Function

Function AddCommasPaddedNUM$ (numeral)
    Shared FieldLineNum
    s$ = LTrim$(Str$(numeral))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)
    Padded$ = Right$("000,000,000,000", FieldLineNum)
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    AddCommasPaddedNUM$ = Padded$
End Function

Function AddCommasPaddedLEN$ (numeral)
    Shared FieldLineLen
    s$ = LTrim$(Str$(numeral))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)
    Padded$ = Right$("000,000,000,000", FieldLineLen)
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    AddCommasPaddedLEN$ = Padded$
End Function

Sub LocateTextGraphCursor (CursorGraphX, CursorGraphY, Visibility, CurS, CurE)
    Shared GraphicOrTextFlag
    Locate CursorGraphX, CursorGraphY, Visibility, CurS, CurE
    If GraphicOrTextFlag = 1 Then
        If Visibility Then
            Line ((CursorGraphY - 1) * _FontWidth, (CursorGraphX - 1) * _FontHeight)-((CursorGraphY) * _FontWidth - 1, (CursorGraphX) * _FontHeight - 1), 9 - 2 * (Int(Timer) Mod 2), B
        End If
    End If
End Sub

Function InputLineSLASH$ (Irow, Icol, LineLen)
    Static a$
    Shared CurrentWord$, FramesPerSecond
    LocateTextGraphCursor Irow, Icol, 1, CursorS, CursorE
    MaxCol = Icol + LineLen - 1
    CurCol = Icol 'Icol..MaxCol
    'IF CurrentWord$ = "" THEN
    '    IF INSTR(_CLIPBOARD$, CHR$(10)) THEN '_CLIPBOARD$ could be multi-line, so get the first
    '        a2$ = LEFT$(_CLIPBOARD$, INSTR(_CLIPBOARD$, CHR$(10)) - 1)
    '        IF RIGHT$(a2$, 1) = CHR$(13) THEN a2$ = LEFT$(a2$, LEN(a2$) - 1)
    '        a$ = LEFT$(a2$, LineLen - 1) '""
    '    ELSE
    '        a$ = LEFT$(_CLIPBOARD$, LineLen - 1) '""
    '    END IF
    '    CurCol = Icol + LEN(a$)
    'ELSE
    '    a$ = CurrentWord$
    'END IF

    '_Delay .5 ' This kinda fixes the nasty (again) inability to handle release of / - it enters the function as if / was released within?!
    RsmLoopSLASH:
    _KeyClear
    BuggyInLinux& = 0
    Do
        ' Kaze's Galeon's non-fix of the problem (on Fedora 35) below [
        x = _KeyHit
        If x Then
            If x < 0 Then 'negative value means key released
                x = -x
                If x = 47 And _KeyDown(47) = 0 Then Exit Do
            Else
            End If
        End If
        ' Kaze's Galeon's non-fix of the problem (on Fedora 35) below ]

        '    ' On Windows 10, after a minute, self activating?!
        '    'BuggyInLinux& = _KeyDown(96)
        '    'If BuggyInLinux& Then
        '    '    IsTILDEreleased = -1
        '    'Else
        '    '    If IsTILDEreleased = -1 Then IsTILDEreleased = 1 Else IsTILDEreleased = 0
        '    'End If
        '    'If IsTILDEreleased = 1 Then IsTILDEreleased = 0: Exit Do

        key$ = InKey$
        ' Even this doesn't fix it fully, holding for 5+ seconds triggers .... release?! [
        'If key$ <> "" Then
        '    BuggyInLinux& = _KeyDown(96)
        'End If
        'If BuggyInLinux& Then
        '    BuggyInLinux& = _KeyDown(96)
        '    IsTILDEreleased = -1
        'Else
        '    If IsTILDEreleased = -1 Then IsTILDEreleased = 1 Else IsTILDEreleased = 0
        'End If
        'If IsTILDEreleased = 1 Then IsTILDEreleased = 0: Exit Do
        ' Even this doesn't fix it fully, holding for 5+ seconds triggers .... release?! ]

        If key$ <> "" Then
            code% = Asc(key$):
            If code% Then ' ASC returns any value greater than 0
                Select Case Asc(key$)
                    Case 47: 'nothing
                    Case 27:
                        a$ = "": CurCol = Icol
                        'Case 13:
                        '        If a$ <> "" Then Exit Do
                    Case 8: 'Backspace
                        If CurCol <> Icol Then
                            If CurCol = Icol + Len(a$) Then ' this condition includes a$ = ""
                                a$ = Left$(a$, Len(a$) - 1)
                            Else 'inhere we are not at the end i.e. 1..len(a$)-1
                                a$ = Left$(a$, (CurCol - Icol) - 1) + Right$(a$, Len(a$) - (CurCol - Icol))
                            End If
                            CurCol = CurCol - 1
                        End If
                    Case 32 TO 127 - 1:
                        If Len(a$) < LineLen - 1 Then 'a$ = a$ + key$: CurCol = CurCol + 1 '-1 because cursor goes next to the field otherwise
                            If CurCol = Icol + Len(a$) Then ' this condition includes a$ = ""
                                a$ = a$ + key$
                            Else 'inhere we are not at the end i.e. 1..len(a$)-1
                                ' Insert at (CurCol - Icol) + 1:
                                a$ = Left$(a$, (CurCol - Icol)) + key$ + Right$(a$, Len(a$) - (CurCol - Icol))
                            End If
                            CurCol = CurCol + 1
                        End If
                End Select
            Else
                If Len(key$) > 1 Then
                    Select Case Asc(key$, 2)
                        Case 75: If CurCol > Icol Then CurCol = CurCol - 1
                        Case 77: If CurCol < MaxCol And CurCol < Icol + Len(a$) Then CurCol = CurCol + 1
                        Case 71: CurCol = Icol 'Home
                        Case 79: CurCol = Icol + Len(a$) 'End
                        Case 83: 'Del
                            If a$ <> "" Then
                                a$ = Left$(a$, (CurCol - Icol)) + Right$(a$, Len(a$) - (CurCol - Icol) - 1)
                            End If
                        Case 82: 'Ins
                    End Select
                End If
            End If
        End If
        LocateTextGraphCursor Irow, Icol, 0, CursorS, CursorE
        Print String$(LineLen, " ");
        LocateTextGraphCursor Irow, Icol, 0, CursorS, CursorE
        Print a$;
        LocateTextGraphCursor Irow, CurCol, 1, CursorS, CursorE
        _Display
        _Limit 30 ' had to comment it out due to slow hiding-n-drawing of the inverse line - it was flickering
    Loop
    _Limit FramesPerSecond
    ' Stupid pseudo-fix of the buggy behavior (injecting 1's and 0's when only 0's are expected) on Fedora 35 [
    For i = 1 To 3333
        StupidFix$ = InKey$
        If _KeyDown(47) Then GoTo RsmLoopSLASH
    Next
    ' Stupid pseudo-fix of the buggy behavior (injecting 1's and 0's when only 0's are expected) on Fedora 35 ]
    InputLineSLASH$ = a$
End Function

Function DrawBoxShadow3exactSLASH4$ (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, filecount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    'Shadow
    BckGRcolor = 4
    Color 8, BACKGR
    For i = 1 To YdimROW 'MIN&(YdimROW, filecount)
        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
        'ELSE
        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
        'END IF
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            'LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
            'LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Mid$(String$(XdimCOL, Chr$(176)), TopLcol + 1, BottomRcol - TopLcol + 1);
            ' When using smooth scroll i.e. not on CHAR boundary we need GRAPHICAL darkening [
            CursorGraphX = i
            For CursorGraphY = (TopLcol + 1) To (TopLcol + 1) + BottomRcol - TopLcol
                'Line ((CursorGraphY - 1) * _FontWidth, (CursorGraphX - 1) * _FontHeight)-((CursorGraphY) * _FontWidth - 1, (CursorGraphX) * _FontHeight - 1), 8, B
                For PX = (CursorGraphY - 1) * _FontWidth To (CursorGraphY) * _FontWidth - 1
                    For PY = (CursorGraphX - 1) * _FontHeight To (CursorGraphX) * _FontHeight - 1
                        Pcolor~& = Point(PX, PY)
                        If Pcolor~& <= 15 Then ' don't change if already shadowed
                            Line (PX, PY)-(PX, PY), Pcolor~& + 16 '1
                        End If
                    Next
                Next
            Next
            ' When using smooth scroll i.e. not on CHAR boundary we need GRAPHICAL darkening ]
        End If
    Next
    _Display: _Delay .3
    'Outer frame
    LocateTextGraphCursor TopLrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: LocateTextGraphCursor TopLrow, TopLcol + 2, 0, CursorS, CursorE: Print "[ ";: Color 15 - 8, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: LocateTextGraphCursor i, TopLcol, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor BottomRrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)
    'Inner frame
    LocateTextGraphCursor TopLrow + 1, TopLcol + 1, 0, CursorS, CursorE
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));
    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 2 To TopLrow + 3
        Color 0, BckGRcolor: LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor TopLrow + 3, TopLcol + 1, 0, CursorS, CursorE
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    LocateTextGraphCursor TopLrow + 2, TopLcol + 2, 0, CursorS, CursorE
    Color 7, BckGRcolor

    HelpLine1$ = "Edit keys, allowed: Home, Left, Right, End, Backspace, Del, Esc, /(released)"
    HelpLine2$ = "Wildcards, allowed: '*' any character(s) or empty; '#' any character and not empty"
    LocateTextGraphCursor TopLrow + 4, TopLcol + 2, 0, CursorS, CursorE: Print HelpLine1$
    LocateTextGraphCursor TopLrow + 5, TopLcol + 2, 0, CursorS, CursorE: Print HelpLine2$
    _Display
    DrawBoxShadow3exactSLASH4$ = InputLineSLASH$(TopLrow + 2, TopLcol + 2, BottomRcol - TopLcol - 1 - 2)
    LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
End Function

Function DrawBoxShadow3exactSLASH5$ (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, filecount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    'Shadow
    BckGRcolor = 5
    Color 8, BACKGR
    For i = 1 To YdimROW 'MIN&(YdimROW, filecount)
        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
        'ELSE
        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
        'END IF
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            'LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
            'LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Mid$(String$(XdimCOL, Chr$(176)), TopLcol + 1, BottomRcol - TopLcol + 1);
            ' When using smooth scroll i.e. not on CHAR boundary we need GRAPHICAL darkening [
            CursorGraphX = i
            For CursorGraphY = (TopLcol + 1) To (TopLcol + 1) + BottomRcol - TopLcol
                'Line ((CursorGraphY - 1) * _FontWidth, (CursorGraphX - 1) * _FontHeight)-((CursorGraphY) * _FontWidth - 1, (CursorGraphX) * _FontHeight - 1), 8, B
                For PX = (CursorGraphY - 1) * _FontWidth To (CursorGraphY) * _FontWidth - 1
                    For PY = (CursorGraphX - 1) * _FontHeight To (CursorGraphX) * _FontHeight - 1
                        Pcolor~& = Point(PX, PY)
                        If Pcolor~& <= 15 Then ' don't change if already shadowed
                            Line (PX, PY)-(PX, PY), Pcolor~& + 16 '1
                        End If
                    Next
                Next
            Next
            ' When using smooth scroll i.e. not on CHAR boundary we need GRAPHICAL darkening ]
        End If
    Next
    _Display: _Delay .3
    'Outer frame
    LocateTextGraphCursor TopLrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: LocateTextGraphCursor TopLrow, TopLcol + 2, 0, CursorS, CursorE: Print "[ ";: Color 15 - 8, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: LocateTextGraphCursor i, TopLcol, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor BottomRrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)
    'Inner frame
    LocateTextGraphCursor TopLrow + 1, TopLcol + 1, 0, CursorS, CursorE
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));
    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 2 To TopLrow + 3
        Color 0, BckGRcolor: LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor TopLrow + 3, TopLcol + 1, 0, CursorS, CursorE
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    LocateTextGraphCursor TopLrow + 2, TopLcol + 2, 0, CursorS, CursorE
    Color 7, BckGRcolor

    HelpLine1$ = "Edit keys, allowed: Home, Left, Right, End, Backspace, Del, Esc, /(released)"
    HelpLine2$ = "Wildcards, allowed: '*' any character(s) or empty; '#' any character and not empty"
    LocateTextGraphCursor TopLrow + 4, TopLcol + 2, 0, CursorS, CursorE: Print HelpLine1$
    LocateTextGraphCursor TopLrow + 5, TopLcol + 2, 0, CursorS, CursorE: Print HelpLine2$
    _Display
    DrawBoxShadow3exactSLASH5$ = InputLineSLASH$(TopLrow + 2, TopLcol + 2, BottomRcol - TopLcol - 1 - 2)
    LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
End Function

Function EpochTime~&&
    DATEstamp$ = Date$: TIMEstamp$ = Time$
    Do While DATEstamp$ <> Date$ 'redo
        DATEstamp$ = Date$: TIMEstamp$ = Time$
    Loop
    m = Val(Left$(DATEstamp$, 2))
    d~&& = Val(Mid$(DATEstamp$, 4, 2))
    y~&& = Val(Right$(DATEstamp$, 4)) - 1970
    For i = 1 To m
        Select Case i 'Add the number of days for each previous month passed
            Case 1: d~&& = d~&& 'January doestn't have any carry over days.
            Case 2, 4, 6, 8, 9, 11: d~&& = d~&& + 31
            Case 3: d~&& = d~&& + 28
            Case 5, 7, 10, 12: d~&& = d~&& + 30
        End Select
    Next
    d~&& = d~&& + y~&& * 365
    For i = 2 To y Step 4
        If m > 2 Then d~&& = d~&& + 1 'add an extra day for leap year every 4 years, starting in 1970
    Next
    d~&& = d~&& - 1 'for year 2000
    EpochTime~&& = d~&& * 24 * 60 * 60 + Val(Left$(TIMEstamp$, 2)) * 3600 + Val(Mid$(TIMEstamp$, 4, 2)) * 60 + Val(Right$(TIMEstamp$, 2))
End Function

